package cs108;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public final class STreeSet<E extends Comparable<E>> extends SAbstractSet<E> {
    private int size = 0;
    private Node<E> root = null;
    
    @Override
    public int size() {
        return size;
    }

    @Override
    public boolean contains(E e) {
        Node<E> maybeNode = nodeOrParent(e);
        return maybeNode != null && maybeNode.elem.compareTo(e) == 0;
    }

    @Override
    public void add(E e) {
        Node<E> n = nodeOrParent(e);
        if (n == null)
            root = new Node<>(e);
        else {
            int c = e.compareTo(n.elem);
            if (c < 0)
                n.lt = new Node<>(e);
            else if (c > 0)
                n.gt = new Node<>(e);
        }
    }

    @Override
    public void remove(E e) {
        // TODO Auto-generated method stub

    }

    @Override
    public Iterator<E> iterator() {
        return new Iterator<E>() {
            private List<E> parents = new ArrayList<>();
            private Node<E> next;

            @Override
            public boolean hasNext() {
                // TODO Auto-generated method stub
                return false;
            }

            @Override
            public E next() {
                // TODO Auto-generated method stub
                return null;
            }
            
        };
    }

    private Node<E> nodeOrParent(E e) {
        Node<E> n = root;
        for (;;) {
            int c = e.compareTo(root.elem);
            if (c < 0 && n.lt != null)
                n = n.lt;
            else if (c > 0 && n.gt != null)
                n = n.gt;
            else
                return n;
        }
    }
    
    private final static class Node<E> {
        private Node<E> lt, gt;
        private E elem;
        
        public Node(Node<E> lt, E elem, Node<E> gt) {
            this.lt = lt;
            this.elem = elem;
            this.gt = gt;
        }
        
        public Node(E elem) {
            this(null, elem, null);
        }
    }
}
